*******************************************************************************
*                           Calibration Etape 1:                              *
*******************************************************************************


*********************Option****************************************************
*Option: si des tarifs ad valorem sont appliques dans ce modele
* enlever l'etoile pour activer la ligne $setglobal tarifadvalorem
*Option: si des tarifs specifiques sont appliques dans ce modele
* enlever l'etoile pour activer la ligne $setglobal tarifspecific

*$setglobal tarifadvalorem YES
$setglobal tarifspecific YES
*******************************************************************************


*** Definition des parametres d'activation des options
parameter advalorem parametre permettant d'activer l'option tarif ad valorem ;
advalorem = 0;
$if setglobal tarifadvalorem advalorem=1 ;

parameter specific parametre permettant d'activer l'option tarif specifique ;
specific = 0;
$if setglobal tarifspecific specific=1 ;

***Dfinitions des ensembles
SET i pays commerant entre eux
/
KEN    Kenya
TZA    Tanzania
UGA    Uganda
ZMB    Zambia
ZWE    Zimbabwe
/;

alias (i,j,jj) ;

***Dclaration des paramtres
Parameters
*Paramtres associs aux flux commerciaux
                 trade01(i,j)           Matrice initiale des flux commerciaux de i  j (en tonne)
$CALL GDXXRW.EXE Inputs_Excel\Net_Trade.xls  o=GDXFiles\Net_Trade.gdx par=trade01 rng=sheet1!A1:F6  Rdim=1 Cdim=1
$GDXIN GDXFiles\Net_Trade.gdx
$LOAD trade01 = trade01
$GDXIN

*Paramtres associs aux cots de transports
                 transportcost1(i,j)    Matrice initiale des cots de transports de i  j (en USD par tonne)
$CALL GDXXRW.EXE Inputs_Excel\Transport_costs.xls  o=GDXFiles\Transport_costs.gdx par=transportcost1 rng=sheet1!A1  Rdim=1 Cdim=1
$GDXIN GDXFiles\Transport_costs.gdx
$LOAD transportcost1 = transportcost1
$GDXIN

Parameters
                avt(i,j)               Droits de douane ad valorem entre pays  (en pourcentage)
                sdt(i,j)               Droits de douane spcifiques entre pays (en USD par tonne)   ;

$If not setglobal tarifadvalorem avt(i,j)=0
$If not setglobal tarifadvalorem $goto skip1
$If not setglobal tarifspecific sdt(i,j)=0

$CALL GDXXRW.EXE Inputs_Excel\TariffsAV.xls  o=GDXFiles\TariffsAV.gdx par=avt rng=sheet1!A1  Rdim=1 Cdim=1
$GDXIN GDXFiles\TariffsAV.gdx
$LOAD avt = avt
$GDXIN
$If not setglobal tarifspecific $goto skip2

$label skip1
$CALL GDXXRW.EXE Inputs_Excel\TariffsSD.xls  o=GDXFiles\TariffsSD.gdx par=sdt rng=sheet1!A1  Rdim=1 Cdim=1
$GDXIN GDXFiles\TariffsSD.gdx
$LOAD sdt = sdt
$GDXIN
$label skip2

Parameter
*Paramtres supplmentaires
                 prodprice1(i)          Prix initial du producteur (en USD par tonne)
/
KEN              182.8227
TZA              182.8227
UGA              182.8227
ZMB              182.8227
ZWE              196.0263
/
                 TTC0                   Cot  l'change total initial de i  j (en USD par tonne)
                 e(i)                   Excs de demande en i (en tonne) ;

***Dfinition des paramtres
*Les cots de transports au sein d'un mme pays sont nuls par hypothese.
transportcost1(i,i) = 0;
TTC0 = sum{(i,j),{[transportcost1(i,j)+ sdt(i,j)$specific + (prodprice1(i)*avt(i,j))$advalorem]*trade01(i,j)}};
e(i) = sum[(j),trade01(j,i)-trade01(i,j)];

***Dclaration des variables
Variables
                 trade1(i,j)            Matrice des flux commerciaux de i  j (en KG)
                 TTC                    Cots  l'change total de i  j (en USD par tonne);
Positive variables
                 trade1 ;

***Initialisation des variables
trade1.l(i,j)    = trade01(i,j);
TTC.l            = TTC0;

***Dclaration des quations
Equations
                 Eq_TTC                 Equation de minimisation de la somme du cot  l'change total (Fonction Objectif)
                 Eq_Mkt(i)              Contrainte d'quilibre du march ;

***Dfinition des quations
Eq_TTC..                     sum{(i,j),[transportcost1(i,j)+ sdt(i,j)$specific + (prodprice1(i)*avt(i,j))$advalorem]*trade1(i,j)} =e= TTC ;
Eq_Mkt(i)..                  e(i) =e= sum[j,trade1(j,i)-trade1(i,j)]  ;

***Dfinition du modle et des quations  prendre en compte dans le modle
Model Calibration1 Modle d'quilibre partiel /all/ ;

***Dtermine l'espace mmoire
Calibration1.workspace = 125 ;

***GAMS met automatiquement le modle  chelle et prsente les rsultats aprs avoir inverser l'chelle afin de retrouver les
***units d'origine.
Calibration1.scaleopt=1;

***Dtermine le nombre de dcimales  inclure
OPTION DECIMALS=8;

***Choisit le solver. Ici, le solver CONOPT est utilis. C'est un solver employ pour des optimisations linaires et non-linaires de grande
***chelle.
OPTION LP = CONOPT;

***Rsoud le programme Calibration1, en utilisant un programme linaire (Linear Programs)
Solve Calibration1 MINIMIZING TTC USING LP;

***Dclaration des paramtres qui seront utiliss dans la prochaine tape du calibrage: Calibration2.
Parameters
                 trade02(i,j)           Quantit exporte de i  j aprs l'tape A de la calibration (en KG)
                 transportcost02(i,j)   Cots de transport entre i et j aprs l'tape A de la calibration  (en USD par tonne)
                 prodprice02(i)         Prix du producteur en i aprs l'tape A de la calibration (en USD par tonne) ;

***Dfinition des paramtres qui seront utiliss dans la prochaine tape du calibrage: Calibration2.
trade02(i,j)             = trade1.l(i,j);
transportcost02(i,j)     = transportcost1(i,j);
prodprice02(i)           = prodprice1(i);




