*******************************************************************************
*                           Calibration Etape 2:                              *
*******************************************************************************

***Dclaration des paramtres
Parameters
*Paramtres associs  la fonction objectif initiale
                 wtc                      Pondration associe au cots de transports (dpend du degre de fiabilit des donnes)
                 wp                       Pondration associe au prix d'offre (dpend du degre de fiabilit des donnes)
*Paramtres associs  l'quation de chainage des prix
                 demand02(i)              Demande initiale en i (en tonne)
                 consprice02(i)           Prix initial du consommateur en i (en USD par tonne)
*Paramtres associs  la fonction de pnalit
                 mu                       Paramtre utilis dans la condition de complmentarit
                 pi0(i,j)                 Rsidu initial de l'quation de chainage des prix  (en USD par tonne)
                 pen0                     Pnalit initiale  (en USD par tonne)
*Paramtres associs  la nouvelle fonction objectif
                 z0                       Fonction objectif initiale (sans la pnalit)  (en USD par tonne)
                 zz0                      Nouvelle fonction objectif initiale (avec la pnalit) (en USD par tonne) ;

***Dfinition des paramtres
wtc                              = 1;
wp                               = 100;
demand02(j)                      = sum[i,trade02(i,j)];
consprice02(i)$trade02(i,i)      = prodprice02(i);
consprice02(i)$((trade02(i,i)=0) and (sum(j,trade02(j,i))>0)) = smin{j,prodprice02(j)+transportcost02(j,i)+ sdt(j,i)$specific
                                                                 + [(transportcost02(j,i)+prodprice02(j))*avt(j,i)]$advalorem
                                                                 - consprice02(i)} ;
mu                       = 0.0001;

*pi0 doit tre positif.
pi0(i,j) = abs[transportcost02(i,j)+ sdt(i,j)$specific
         + [(transportcost02(i,j)+prodprice02(i))*avt(i,j)]$advalorem
         - consprice02(j)+ prodprice02(i)] ;

pen0     = mu*sum[(i,j),pi0(i,j)*trade02(i,j)];
z0       = wtc*sum{(i,j),power(transportcost02(i,j)-transportcost1(i,j),2)}+ wp*sum{i,power(prodprice02(i)-prodprice1(i),2)};
zz0      = z0+ pen0;

***Dclaration des variables
Variables
                 z                        Fonction objectif (sans la pnalit) (en USD par tonne)
                 zz                       Nouvelle fonction objectif (avec la pnalit) (en USD par tonne)

Positive Variables
                 transportcost2(i,j)      Cots de transports de i  j  (en USD par tonne)
                 prodprice2(i)            Prix d'offre en i  (en USD par tonne)
                 consprice2(i)            Prix de demande en i  (en USD par tonne)
                 pi(i,j)                  Rsidu de l'quation de chainage des prix  (en USD par tonne)
                 pen                      Pnalit  (en USD par tonne)
;

***Initialisation des variables
transportcost2.l(i,j)    = transportcost02(i,j);
prodprice2.l(i)          = prodprice02(i);
consprice2.l(i)          = consprice02 (i);
pi.l(i,j)                = pi0(i,j);
pen.l                    = pen0;
z.l                      = z0;
zz.l                     = zz0;

***Dclaration des quations
Equations
                 Eq_Obj                 Fonction objectif (sans la pnalit)
                 Eq_PRLINK1(i,j)        Premire quation de relation des prix
                 Eq_Pen                 Condition de complmentarit
                 Eq_zz                  Nouvelle fonction objectif (avec la pnalit)
                 Eq_tc                  Absence de cout de transport sur les ventes locales
         ;

***Dfinition des quations
Eq_Obj..                                z =e= wtc*sum{(i,j),power(transportcost2(i,j)-transportcost1(i,j),2)}+ wp*sum{i,power(prodprice2(i)-prodprice1(i),2)} ;
Eq_PRLINK1(i,j)..                       prodprice2(i) + transportcost2(i,j)+ sdt(i,j)$specific
                                        + [(transportcost2(i,j)+ prodprice2(i))*avt(i,j)]$advalorem =e= consprice2(j)+pi(i,j);
Eq_Pen..                                mu*sum[(i,j),pi(i,j)*trade02(i,j)] =e= pen ;
Eq_zz..                                 z+ pen =e= zz ;
Eq_tc(i)..                              transportcost2(i,i) =e= 0 ;


***Dfinition du modle et des quations  prendre en compte dans le modle
Model Calibration2 Modle d'quilibre partiel /
Eq_Obj
Eq_PRLINK1
Eq_Pen
Eq_zz
Eq_tc
/;

***Dtermine l'espace mmoire
Calibration2.workspace = 125 ;

***GAMS met automatiquement le modle  chelle et prsente les rsultats aprs avoir inverser l'chelle afin de retrouver la
***solution originale.
Calibration2.scaleopt=1;

***Dtermine le nombre de dcimales  inclure
OPTION DECIMALS=8;

***Choisit le solver. Ici, le solver CONOPT est utilis. C'est un solver employ pour des optimisations non-linaires de grande
***chelle.
OPTION NLP = CONOPT;

***Augmente progressivement la valeur de mu afin d'obliger le rsidu de l'quation de chainage des prix  diminuer jusqu'
***atteindre zero. Rsoud le programme Calibration2, en utilisant un programme non-linaire (Non Linear Programs).
while(( (pen.l/mu) ge 0.00000000000001),
Solve Calibration2 MINIMIZING zz USING nlp;
mu = mu+0.00005 ;
) ;

***Dclaration des paramtres qui seront utiliss dans le modle standard et dans les deux scnarios.
Parameter
                 transportcost03(i,j)   Cots de transports aprs l'tape B de la calibration (en USD par tonne)
                 prodprice03(i)         Prix d'offre aprs l'tape B de la calibration (en USD par tonne)
                 consprice03(i)         Prix de demande aprs l'tape B de la calibration  (en USD par tonne) ;

***Dfinitin des paramtres qui seront utiliss dans le modle standard et dans les deux scnarios.
transportcost03(i,j)     = transportcost2.l(i,j);
prodprice03(i)           = prodprice2.l(i);
consprice03(i)           = consprice2.l(i);

