*******************************************************************************
*                              Modle: Scnario B                             *
*******************************************************************************
***Dclaration des paramtres
PARAMETERS
                 supply03(i)                       Offre initiale en i (en KG)
                 A(i)                              Ordonne  l'origine de la fonction inverse de demande p=f(q)
                 B(i)                              Valeur absolue de la pente de la fonction inverse de demande p=f(q)
                 C(i)                              Ordonne  l'origine de la fonction inverse d'offre p=f(q)
                 D(i)                              Valeur absolue de la pente de la fonction inverse d'offre p=f(q) ;

Parameter

                 sup_cost(i,j)                     Parametre permettant la simulation d'un cout supplementaire aux transactions de i a j      ;

sup_cost(i,j) = 0 ;

***Dfinition des paramtres
supply03(i)  = sum[j,trade02(i,j)];

Parameter  Ed(i)
*Nous prenons le cas d'une elasticte-prix de la demande de
/
KEN    0.148
TZA    0.078
UGA    0.002
ZMB    0.014
ZWE    0.001
/;


Parameter  Es(i)
*Nous prenons le cas d'une elasticte-prix de l'offre de
/
KEN    1.7
TZA    1.3
UGA    1.2
ZMB    1.5
ZWE    1.1
/;

* On en deduit les parametres de la fonction inverse de demande
B(i)$demand02(i)= consprice03(i)/(demand02(i)*Ed(i));
D(i)$supply03(i)= prodprice03(i)/(supply03(i)*Es(i));

*********Les formules precedentes ne s'appliquent que si il y a une demande positive et une offre positive
*********pour les autres pays on applique la moyenne des autres pentes de fonctions
parameters countd, counts ;
countd=0;
counts=0;
loop(i,
         countd$demand02(i)=countd+1;
         counts$supply03(i)=counts+1
     ) ;

B(i)$(demand02(i)=0)= sum(j$demand02(j),B(j))/countd;
D(i)$(supply03(i)=0)= sum(j$supply03(j),D(j))/counts;

A(i)=  consprice03(i)+ B(i)*demand02(i) ;
C(i)=  prodprice03(i)-D(i)*supply03(i) ;

***Dclaration des variables
POSITIVE VARIABLES
                 demand(i)                         Quantit demande en i (en KG)
                 supply(i)                         Quantit offerte en i  (en KG)
                 consprice3(i)                     Prix de demande en i (en USD par tonne)
                 prodprice3(i)                     Prix d'offre en i  (en USD par tonne)
                 trade3(i,j)                       Matrice de flux commerciaux de i  j (en KG) ;

***Initialisation des variables
demand.l(i)               = demand02(i) ;
supply.l(i)               = supply03(i) ;
consprice3.l(i)           = consprice03(i);
prodprice3.l(i)           = prodprice03(i);
trade3.l(i,j)             = trade02(i,j);

***Dclaration des quations
EQUATIONS
                 Eq_PROD(i)                        Quantit produite suprieure  quantit exporte dans toutes les pays
                 Eq_DEM(i)                         Quantit demande infrieure  quantit exporte dans chaque pays
                 Eq_DPRICEDIF(i)                   Diffrence entre le prix de demande et le prix de demande locale
                 Eq_SPRICEDIF(i)                   Diffrence entre le prix d'offre et le prix d'offre locale
                 PRLINK2(i,j)                      Seconde contrainte de prix       ;

***Dfinition des quations
Eq_PROD(i)..           supply(i) =G= sum[j,trade3(i,j)] ;
Eq_DEM(i)..            sum[j,trade3(j,i)] =G= demand(i);
Eq_DPRICEDIF(i)..      consprice3(i) =G= A(i)- B(i)*demand(i) ;
Eq_SPRICEDIF(i)..      C(i) + D(i)*supply(i)=G= prodprice3(i);
PRLINK2(i,j)..         prodprice3(i)+ transportcost03(i,j)+ sup_cost(i,j)+sdt(i,j)$specific
                       + [(transportcost03(i,j)+ prodprice3(i) + sup_cost(i,j))*avt(i,j)]$advalorem =G= consprice3(j);

***Dfinit le modle. Celui-ci sera rsolu par un problme de complmentarit mixte (Mixed Complementarity Problem - MCP).
*Il faut donc associer chaque quation  une variable.
MODEL SPATIAL Modle d'quilibre partiel
/
Eq_PROD.prodprice3
Eq_DEM.consprice3
Eq_DPRICEDIF.demand
Eq_SPRICEDIF.supply
PRLINK2.trade3
/;

***Dtermine l'espace mmoire
SPATIAL.workspace = 125 ;

***Dtermine le nombre de dcimales  inclure
OPTION DECIMALS=8;

***Rsoud le modle, en utilisant un probme de complmentarit mixte (Mixed Complementarity Problem - MCP)
SOLVE SPATIAL using MCP;

***Dclaration de paramtres qui vont permettre de fixer les valeurs de certaines variables cls, obtenues avant le choc, comme
***valeurs initiales de ces variables.
PARAMETER
                 trade3_ini(i,j)                   Quantit initiale change de i  j  (en KG)
                 totaltrade_ini                    Quantit initiale totale change entre i et j (en KG)
                 exports_ini(i)                    Quantit initiale exporte en provenance de i (en KG)
                 imports_ini(j)                    Quantit initiale importe par j (en KG)
                 supply_ini(i)                     Offre initiale  (en KG)
                 demand_ini(i)                     Demande intiale (en KG)
                 totalsupply_ini                   Offre totale initiale (en KG)
                 totaldemand_ini                   Demande totale initiale (en KG)
                 consprice3_ini(i)                 Prix initial de la demande de march  (en USD par tonne)
                 prodprice3_ini(i)                 Prix inital de l'offre de march (en USD par tonne)
                 CoS_ini(i)                        Surplus initial du consommateur (en Mios USD)
                 PrS_ini(i)                        Surplus initial du producteur (en Mios USD)
                 PR_ini(i)                         Revenu public initial (en Mios USD)
                 welfare_ini(i)                    Bien-tre initial (en Mios USD)
                 worldwelfare_ini                  Bien-tre mondial initial (en Mios USD) ;

***Dfinition des paramtres mentionns ci-dessus.
trade3_ini(i,j)          = trade3.l(i,j) ;
totaltrade_ini           = sum[(i,j),trade3.l(i,j)];
exports_ini(i)           = sum[j$(ord(j) ne ord(i)), trade3.l(i,j)];
imports_ini(j)           = sum{i$[ord(i) ne ord(j)], trade3.l(i,j)};
supply_ini(i)            =  supply.l(i) ;
demand_ini(i)            = demand.l(i) ;
totalsupply_ini          = sum[i, supply.l(i)];
totaldemand_ini          = sum[i, demand.l(i)];
consprice3_ini(i)        = consprice3.l(i) ;
prodprice3_ini(i)        = prodprice3.l(i) ;
CoS_ini(i)               = B(i)*[demand.l(i)**2]/2/1000000;
PrS_ini(i)               = D(i)*[supply.l(i)**2]/2/1000000;
PR_ini(j)                = {sum{i,{sdt(i,j)$specific
                           + [(transportcost03(i,j)+ prodprice3.l(i)+ sup_cost(i,j))*avt(i,j)]$advalorem}*trade3.l(i,j)}}/1000000 ;
welfare_ini(i)           = [CoS_ini(i) + PrS_ini(i) + PR_ini(i)]/1000000 ;
worldwelfare_ini         = sum[i,welfare_ini(i)]/1000000 ;

***Implmentation du scnario B: augmentation des cots de transports sur les exportations en provenance d'Uganda vers tous ses partenaires.
***Pas d'augmentation des cots de transports au sein mme de l'Uganda.

sup_cost('UGA',j)        = 50 ;
sup_cost('UGA','UGA')    = 0 ;

***Rsoud de nouveau le programme, avec le choc (Scnario B), en utilisant un problme de complmentarit mixte (Mixed Complementarity Problem - MCP).
SOLVE SPATIAL using mcp ;

***Dclaration des mmes paramtres cls. Or cette fois-ci, leurs valeurs dpendent des valeurs des variables aprs le choc, et non avant le choc.
***De ce fait, elles ne correspondent plus  des valeurs initiales. Ceci permet de comparer les valeurs de variables cls avant et aprs choc.
Parameters
                 totaltrade                        Echanges totaux (en tonnes)
                 exports(i)                        Exportations de i (en tonnes)
                 imports(j)                        Importations de j (en tonnes)
                 totalsupply                       Offre totale (en tonnes)
                 totaldemand                       Demande totale (en tonnes)
                 CoS(i)                            Surplus du consommateur (en Mios USD)
                 PrS(i)                            Surplus du producteur (en Mios USD)
                 PR(i)                             Revenu public (en Mios USD)
                 welfare(i)                        Bien-tre (en Mios USD)
                 worldwelfare                      Bien-tre mondial (en Mios USD) ;

***Dfinition de ces paramtres cls
totaltrade       = sum[(i,j),trade3.l(i,j)];
exports(i)       = sum[j$(ord(j) ne ord(i)), trade3.l(i,j)];
imports(j)       = sum{i$[ord(i) ne ord(j)], trade3.l(i,j)};
totalsupply      = sum[i, supply.l(i)];
totaldemand      = sum[i, demand.l(i)];
CoS(i)           = B(i)*(demand.l(i)**2)/2/1000000;
PrS(i)           = D(i)*(supply.l(i)**2)/2/1000000;
PR(j)            = {sum{i,{sdt(i,j)$specific
                    + [(transportcost03(i,j)+ prodprice3.l(i)+ sup_cost(i,j))*avt(i,j)]$advalorem}*trade3.l(i,j)}}/1000000 ;
welfare(i)       = [CoS(i) + PrS(i) + PR(i)]/1000000 ;
worldwelfare     = sum[i,welfare(i)]/1000000 ;

***Dclaration de paramtres de variation. Ces paramtres reprsentent les variations existantes entre les valeurs des variables avant et aprs le choc.
Parameters
                 var_trade(i,j)                    Variation dans la quantit change de i  j (en pourcentage)
                 var_totaltrade                    Variation dans la quantit totale change (en pourcentage)
                 var_exports(i)                    Variation dans la quantit exporte de i (en pourcentage)
                 var_imports(j)                    Variation dans la quantit importe par j (en pourcentage)
                 var_supply(i)                     Variation dans la quantit offerte en i (en pourcentage)
                 var_demand(i)                     Variation dans la quantit demande en i (en pourcentage)
                 var_totalsupply                   Variation dans la quantit offerte totale (en pourcentage)
                 var_totaldemand                   Variation dans la quantit demande totale (en pourcentage)
                 var_consprice3(i)                 Variation dans le prix de demande (en pourcentage)
                 var_prodprice3(i)                 Variation dans le prix d'offre (en pourcentage)
                 var_CoS(i)                        Variation de surplus du consommateur (en pourcentage)
                 var_PrS(i)                        Variation de surplus du producteur  (en pourcentage)
                 var_PR(i)                         Variation de revenu public  (en pourcentage)
                 var_welfare(i)                    Variation de bien-tre  (en pourcentage)
                 varworldwelfare                   Variation de bien-tre mondial  (en pourcentage);

***Dfinition des paramtres mentionne ci-dessus.
var_trade(i,j)$trade3_ini(i,j)           = 100*[trade3.l(i,j) - trade3_ini(i,j)]/trade3_ini(i,j);
var_totaltrade$totaltrade_ini            = 100*[totaltrade - totaltrade_ini]/totaltrade_ini;
var_exports(i)$exports_ini(i)            = 100*[exports(i) - exports_ini(i)]/exports_ini(i);
var_imports(j)$imports_ini(j)            = 100*[imports(j) - imports_ini(j)]/imports_ini(j);
var_supply(i)$supply_ini(i)              = 100*[supply.l(i) - supply_ini(i)]/supply_ini(i);
var_demand(i)$demand_ini(i)              = 100*[demand.l(i) - demand_ini(i)]/demand_ini(i);
var_totalsupply$totalsupply_ini          = 100*[totalsupply - totalsupply_ini]/totalsupply_ini;
var_totaldemand$totaldemand_ini          = 100*[totaldemand - totaldemand_ini]/totaldemand_ini;
var_consprice3(i)$consprice3_ini(i)      = 100*[consprice3.l(i) - consprice3_ini(i)]/consprice3_ini(i);
var_prodprice3(i)$prodprice3_ini(i)      = 100*[prodprice3.l(i) - prodprice3_ini(i)]/prodprice3_ini(i);
var_CoS(i)$CoS_ini(i)                    = 100*[CoS(i) - CoS_ini(i)]/CoS_ini(i) ;
var_PrS(i)$PrS_ini(i)                    = 100*[PrS(i) - PrS_ini(i)]/PrS_ini(i) ;
var_PR(i)$PR_ini(i)                      = 100*[PR(i) - PR_ini(i)]/PR_ini(i) ;
var_welfare(i)$welfare_ini(i)            = 100*[welfare(i) - welfare_ini(i)]/welfare_ini(i) ;
varworldwelfare$worldwelfare_ini         = 100*[worldwelfare-worldwelfare_ini]/worldwelfare_ini ;
